unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppBands, ppCtrls, ppClass, ppVar, ppPrnabl, ppCache, ppProd,
  ppReport, ppDB, ppComm, ppRelatv, ppTxPipe, StdCtrls;

type
  TForm1 = class(TForm)
    ppTextPipeline1: TppTextPipeline;
    ppTextPipeline1Field1: TppField;
    ppTextPipeline1Field2: TppField;
    ppTextPipeline1Field3: TppField;
    ppTextPipeline1Field4: TppField;
    ppTextPipeline1Field5: TppField;
    ppTextPipeline1Field6: TppField;
    ppReport1: TppReport;
    ppReport1TitleBand1: TppTitleBand;
    ppReport1Label5: TppLabel;
    ppReport1Label10: TppLabel;
    ppReport1Header: TppHeaderBand;
    ppReport1Label1: TppLabel;
    ppReport1Label2: TppLabel;
    ppReport1Detail: TppDetailBand;
    ppReport1DBText2: TppDBText;
    ppReport1DBText8: TppDBText;
    ppReport1DBText3: TppDBText;
    ppReport1DBText4: TppDBText;
    ppReport1DBText5: TppDBText;
    ppReport1DBText6: TppDBText;
    ppReport1DBCalc1: TppDBCalc;
    ppReport1Footer: TppFooterBand;
    ppReport1Calc1: TppSystemVariable;
    ppReport1Calc3: TppSystemVariable;
    ppReport1Group1: TppGroup;
    ppReport1GroupHeaderBand1: TppGroupHeaderBand;
    ppReport1Label3: TppLabel;
    ppReport1Label6: TppLabel;
    ppReport1Label7: TppLabel;
    ppReport1Label8: TppLabel;
    ppReport1Label9: TppLabel;
    ppReport1Line1: TppLine;
    ppReport1Label4: TppLabel;
    ppReport1GroupFooterBand1: TppGroupFooterBand;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FBookmarks: TList;

    procedure BuildBookmarkList;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  liIndex: Integer;
begin

  {assign the file name (ex. current directory + dm0133.txt)}
  ppTextPipeline1.FileName := ExtractFilePath(ParamStr(0)) + 'dm0133.txt';

  FBookmarks := TList.Create;

  BuildBookmarkList;

  {apply bookmarks for datapipeline}
  for liIndex := 0 to FBookmarks.Count-1 do
    ppTextPipeline1.AddBookmark(Integer(FBookmarks[liIndex]));

end;

procedure TForm1.BuildBookmarkList;
var
  liIndex: Integer;
begin

  ppTextPipeline1.Open;
  ppTextPipeline1.First;

  liIndex := 0;

  {bookmark every fourth record}
  while not(ppTextPipeline1.EOF) do
    begin
      Inc(liIndex);

      if (liIndex mod 4) = 0 then
        FBookmarks.Add(Pointer(ppTextPipeline1.GetBookmark));

      ppTextPipeline1.Next;
    end;

end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;

end.
